
(* USER INPUT: *)

(* give -list of loop momenta (momlist)
           -list of propagators (proplist):
	   masses m_i^2 must be called ms[i],  example k^2-m^2= k^2-ms[1]
	   -numerator: list of scalar products of loop momenta contracted with 
	    external vectors or loop momenta; 
	    for scalar integrals numerator={1}; 
	   -list of propagator powers (powerlist), default is 1:
	    powers of propagators as listed in proplist          *)

(* example is non-planar double box with  massive loop attached to p1,p2 and propagator connecting p3 and p4  on-shell massive *)
(* the mass in the propagator connecting p3 and p4 has been called ms[1],  the mass^2 in the massive loop has been called ms[2],  *)

momlist={k1,k2};
proplist={k1^2-ms[1],(k1+p4)^2,(k1-p3)^2,((k1-k2)^2-ms[2]),
((k2+p4)^2-ms[2]),((k1-k2+p2)^2-ms[2]),((k2-p2-p3)^2-ms[2])};
numerator={1};

powerlist=Table[1,{i,Length[proplist]}];

onshell={ssp[1]->0,ssp[2]->0,ssp[3]->ms[1],ssp[4]->ms[1]};

(* note that in constructing F, (pi+pj)^2 will automatically be called sp[i,j]; 
    pi^2 will be called ssp[i];
    masses m_i^2 must be called ms[i];  *)


(* Dim can be changed, but symbol for epsilon must be the same *)
Dim=4-2*eps;


 
