  #****s* SecDec/loop/perlsrc/prefactor.pl
  #  NAME
  #    prefactor.pl
  #
  #  USAGE
  #  is called from results.pl
  #
  #  PURPOSE
  #  creates the mathematica file to generate the numerical prefactor in orders of eps
  #  
  #  INPUTS
  #  parameters parsed via ARGV:
  #  defpre: default prefactor
  #  despre: desired prefactor
  #  outpath: where the files are to be written, together with a prefix for the filenames when applicable
  #  epsord: order required for the calculation.
  #  loops: number of loops, used to define a naive maximal pole.
  #    
  #  RESULT
  #  prefac.m is created, and when it is executed it generates the numerical prefactor
  #    
  #  SEE ALSO
  #  results.pl
  #   
  #****
  #





$defpre=$ARGV[0];
$despre=$ARGV[1];
$outpath=$ARGV[2];
$epsord=$ARGV[3];
$loops=$ARGV[4];
 $despre=~s/openbracket/\(/g;
 $despre=~s/closebracket/\)/g;
 $defpre=~s/openbracket/\(/g;
 $defpre=~s/closebracket/\)/g;
open (PREFAC, ">prefac.m");
 print PREFAC "desiredprefactor=$despre;\n";
 print PREFAC "defaultprefactor=$defpre;\n";
 print PREFAC "outfilepath=\"$outpath\";\n";
 print PREFAC "maxepspole=2*$loops;\n";
 print PREFAC "epsord=$epsord;\n";
 print PREFAC "prefactord=maxepspole+epsord;\n";
 print PREFAC "multiplier=defaultprefactor/desiredprefactor;\n";
 print PREFAC "smulti=Series[multiplier,{eps,0,prefactord}];\n";
 print PREFAC "mysc[msexpr_,msord_]:=If[MatchQ[Head[msexpr],SeriesData],\n";
 print PREFAC "SeriesCoefficient[msexpr,msord],\n";
 print PREFAC "If[MatchQ[msord,0],msexpr,0]];\n";
 print PREFAC "multi[i_]:=N[mysc[smulti,i]];\n";
 print PREFAC "Do[\n ";
 print PREFAC "outfile=StringJoin[outfilepath,\"epsprefactor\",ToString[doi]];\n";
 print PREFAC "OpenWrite[outfile];\n";
 print PREFAC "Write[outfile, multi[doi]];\n";
 print PREFAC "Close[outfile];\n";
 print PREFAC ",\n";
 print PREFAC "{doi,-1,prefactord}\n";
 print PREFAC "]\n";
close PREFAC
