(*
  #****m* SecDec/loop/src/subexp/ExpOpt.m
  #  NAME
  #    ExpOpt.m
  #
  #  USAGE
  #  loaded by formfortran.m
  # 
  #  USES 
  #  Format.m (for FortranAssign), Experimental` (for OptimizeExpression)
  #
  #  USED BY 
  #    
  #  formfortran.m
  #
  #  PURPOSE
  #  Takes an optimized expression from formfortran.m, and writes it in fortran syntax to the appropriate subdirectory.
  #    
  #  INPUTS
  #  from formfortran.m:   
  #  inlist: the optimized expression to be turned into fortran syntax
  #  varletter: the letter each intermediate expression in the optimization will be prefixed by
  #  funcname: the name of the function to be written
  #  outfile: where the file is to be written
  #  fortranstring1,2,3: strings with the necessary fortran syntax
  #  xstring: string with the necessary assignments for x (IBP only), in fortran format.
  #  
  #    
  #  RESULT
  #  the f.f file is written in fortran syntax to the specified subdirectory
  #    
  #  SEE ALSO
  #  formfortran.m, Format.m
  #   
  #****
*)
(* load Sofroniou's Format.m *)
Quiet[<<Experimental`;Get[StringJoin[path,"src/util/","Format.m"]]];
fortassign[variablename_,variablevalue_]:=
(Write[outfile,FortranAssign[variablename,variablevalue]])
cassign[cassargs__]:=
(Write[outfile,CAssign[cassargs,AssignOptimize->False]])

(* module needed below to write to Fortran file *)
writeopt[inlist_,varletter_,funcname_,outfile_]:=Module[{li1,li2,count,le,
         helpstring,fu,repl},
OpenWrite[outfile];
WriteString[outfile, fortranstring1, funcname, fortranstring2];
If[Quiet[ArrayQ[inlist[[1]]]==True],
  li2=inlist[[2]];
  li1=inlist[[1]];
  le=Length[li1];
  count=1;
  repl={};
  Do[
 	varname=StringJoin[varletter,ToString[count]];
	varval=(li2[[j,2]]/.repl);
	fortassign[varname,varval];
  repl=Append[repl,li1[[j]]->ToExpression[StringJoin[varletter,ToString[count]]]];
  count++
  ,{j,le}];
  fu=li2[[le+1]]/.repl;
  Write[outfile,FortranAssign[funcname,fu]];
,(* else no optimization is done, inlist is not a list but can be 
    an expression of a certain Length > 1 *)
  fu=inlist;
  Write[outfile,FortranAssign[funcname,fu]];
];
WriteString[outfile, fortranstring3];
Close[outfile]; 
];

(* module needed by formtoC.m to write to write C files *)
writeoptC[inlist_,varletter_,funcname_,outfile_]:=Module[{li1,li2,count,le,
         helpstring,fu,repl,wcount,vectorreplace,vrexp},
OpenWrite[outfile];
WriteString[outfile, Cstring1, funcname, Cstring2, Cstring3,Cstring3a,Cstring4];
(*,Cstring4a,Cstring5]*)
wwrite={};
If[Quiet[ArrayQ[inlist[[1]]]==True],
  li2=inlist[[2]];
  li1=inlist[[1]];
  le=Length[li1];
  count=1;
  repl={};
  Do[
 	varname[count]=StringJoin[varletter,"[",ToString[count],"]"];
   (*	varname=StringJoin[varletter,ToString[count]];*)
	varval[count]=(li2[[j,2]]/.repl/.{Power[aa_,-1]->1./aa});
(*
vectorreplace=Append[vectorreplace,varletter<>"("<>ToString[count]<>".)"->"w["<>ToString[count]<>"]"];*)
	wwrite={wwrite,imcassign[varname[count],varval[count]]};
  (*repl=Append[repl,li1[[j]]->ToExpression[StringJoin[varletter,ToString[count]]]];*)
		repl=Append[repl,li1[[j]]->ToExpression[varletter][count]];
  (*WriteString[outfile,"double ", varletter];
  Write[outfile,count];*)
  count++
  ,{j,le}];
  wcount=count-1;
		(*vrexp=Join[Table[varletter<>"("<>ToString[i]<>".)"->varletter<>"["<>ToString[i]<>"]",{i,wcount}],
		 Cstringreplacements];*)
(*		
vrexp=(#~~"("~~ShortestMatch[c__]~~".)"->#~~"["~~c~~"]")&/@{varletter,"es","esx","em","xvals"};*) 
  WriteString[outfile,Cstring4a[count],Cstring5];
		wwrite=Flatten[wwrite];
		wwrite=wwrite/.vectorreplace->vrexp;
		#/.{imcassign->cassign}&/@wwrite;
		fu=li2[[le+1]]/.repl;
  Write[outfile,CAssign["FOUT",fu,AssignOptimize->False]];
,(* else no optimization is done, inlist is not a list but can be 
    an expression of a certain Length > 1 *)
  fu=inlist;
		WriteString[outfile,"dcmplx FOUT;\n"];
  cassign["FOUT",fu/.Power[aa_,-1]->1./aa];
];
WriteString[outfile, Cstring6];
WriteString[outfile,"(FOUT);\n}"];
(*WriteString[outfile, Cstring7];*)
Close[outfile]; 
];

